#!/bin/csh

setenv MVERSION_DIR ../posix

$MVERSION_DIR/getsvninfo.pl

egrep SOURCE_ROOT cosmos_8.xcodeproj/project.pbxproj | awk '-Fpath = '  '{print $2}' | awk '-F;' '{print $1}' > tmp
egrep ../../src/arch tmp > tmp2

echo "MACHINE"
$MVERSION_DIR/mversion.pl -update -current ../current.ver -except ../../src/version work -base ../../src/ /env/src/ -code machine_code_version AP.code -log ../version -app cosmos -c ../../src/version/machine.mac.carbon.lib.ver.c -msg GLOBALBASE client -object `cat tmp2`

echo
echo "APPLICATION"
$MVERSION_DIR/mversion.pl -update -current ../current.ver -except ../../src/version work -base ../../src/ /env/src/ -code ap_version AP.code -log ../version -app cosmos -c ../../src/version/cosmos.mac.carbon.ver.c -msg GLOBALBASE client -object `cat tmp`  | egrep 'VERSION=' | awk '-FVERSION=' '{print $2}' > tmp
cp Info.org.plist Info.plist
replace Info.plist ++VERSION++ `cat tmp`

echo -n VERSION=
cat tmp
rm -f tmp
rm -f tmp2

