
sub get_list {
	open(IN,"$_[0] |");
	my @list = ();
	while (<IN>) {
		my $tmp = $_;
		$tmp =~ s/\n//;
		$tmp =~ s/\*//;
		$list[$#list+1] = $tmp;
	}
	close(IN);
	return @list;
}

sub get_svn_list {
	return get_list("svn list $_[0]");
}

sub get_ls_list {
	return get_list("$cmd_ls $_[0]");
}


sub clean_target {
	my $dir = $_[0];
	my $tmp = $_[1];
	$tmp =~ s/\///;
	print "CLEAN $dir/$tmp\n";
	system("$cmd_rm $dir/$tmp");
}

sub parse_dir {

	my $target = $_[0];
print "DIR = $target\n";
	my @svn_dir = sort(get_svn_list($target));
	my @ls_dir = sort(get_ls_list($target));

#print "SVN_DIR @svn_dir\n";
#print "LS_DIR @ls_dir\n";

	my $svn_p = 0;
	my $ls_p = 0;
	for ( ; ; ) {
		if ( $svn_p > $#svn_dir ) {
			for ( ; $ls_p <= $#ls_dir ; $ls_p ++ ) {
				clean_target($target,$ls_dir[$ls_p]);
			}
			last;
		}
		if ( $ls_p >$#ls_dir ) {
			last;
		}
		if ( $svn_dir[$svn_p] eq $ls_dir[$ls_p] ) {
			my $dir = $svn_dir[$svn_p];
			if ( substr($dir,length($dir)-1,1) eq "/" ) {
				$dir =~ s/\///;
				parse_dir("$target/$dir");
			}
			$svn_p ++;
			$ls_p ++;
		}
		elsif ( $svn_dir[$svn_p] lt $ls_dir[$ls_p] ) {
			my $dir = $svn_dir[$svn_p];
			if ( substr($dir,length($dir)-1,1) eq "/" ) {
				$dir =~ s/\///;
				parse_dir("$target/$dir");
			}
			$svn_p ++;
		}
		else {
			clean_target($target,$ls_dir[$ls_p]);
			$ls_p ++;
		}
	}
}


parse_dir(".");

return true;

