
print "mversion.pl\n";

$current = "";
$ver = "-off";
@prefix = ();
@baseSrc = ();
@baseDest = ();
@except = ();
$code1 = "";
$code2 = "";
$log = "";
$application = "";
@object = ();
$target = "";
$msg = "";

sub parsing_arguments {
	my @arg_list = @_;
	my $i = 0;
	for ( ; $i <= $#arg_list ; ) {
		if ( ($arg_list[$i] eq "-on") || 
				($arg_list[$i] eq "-update") ||
				($arg_list[$i] eq "-off") ) {
			$ver = $arg_list[$i];
			$i ++;
		} elsif ($arg_list[$i] eq "-current" ) {
			$current = $arg_list[$i+1];
			$i = $i + 2;
		} elsif ( $arg_list[$i] eq "-prefix" ) {
			$i ++;
			for ( ; ($i <= $#arg_list) && 
					(substr($arg_list[$i],0,1) eq '.') ; $i ++ ) {
				$prefix[$#prefix+1] = $arg_list[$i];
			}
		} elsif ( $arg_list[$i] eq "-base" ) {
			$i ++;
			$baseSrc[$#baseSrc+1] = $arg_list[$i];
			$baseDest[$#baseSrc] = $arg_list[$i+1];
			$i = $i + 2;
		} elsif ( $arg_list[$i] eq "-except" ) {
			$i ++;
			for ( ; ($i <= $#arg_list) && 
					(substr($arg_list[$i],0,1) ne '-') ; $i ++ ) {
				$except[$#except+1] = $arg_list[$i];
			}
		} elsif ( $arg_list[$i] eq "-code" ) {
			$i ++;
			$code1 = $arg_list[$i];
			$i ++;
			$code2 = $arg_list[$i];
			$i ++;
		} elsif ( $arg_list[$i] eq "-log" ) {
			$i ++;
			$log = $arg_list[$i];
			$i ++;
		} elsif ( $arg_list[$i] eq "-app" ) {
			$i ++;
			$application = $arg_list[$i];
			$i ++;
		} elsif ( $arg_list[$i] eq "-object" ) {
			$i ++;
			for ( ; ($i <= $#arg_list) &&
					(substr($arg_list[$i],0,1) ne '-') ; $i ++ ) {
				$object[$#object+1] = $arg_list[$i];
			}
		} elsif ( $arg_list[$i] eq "-c" ) {
			$i ++;
			$target = $arg_list[$i];
			$i ++;
		} elsif ( $arg_list[$i] eq "-msg" ) {
			$i ++;
			for ( ; ($i <= $#arg_list) &&
					(substr($arg_list[$i],0,1) ne '-') ; $i ++ ) {
				$msg = "$msg $arg_list[$i]";
			}
		} elsif ( $arg_list[$i] eq "-f" ) {
			$i ++;
			$args_file = $arg_list[$i];
			open(IN,$args_file);
			my @p_args = ();
			while (<IN>) {
				my @tmp = split(/ |\t/,$_);
				push(@p_args,@tmp);
			}
			parsing_arguments(splice(@p_args,1,$#p_args-1));
			close(IN);
			$i++;
		} elsif ( $arg_list[$i] eq "" ) {
			$i++;
		} else {
			print "invalid option \"$arg_list[$i]\"\n";
			return 0;
		}
	}
	return 0;
}

# print "current = $current\n";
# print "ver = $ver\n";
# print "prefix = @prefix\n";
# print "baseSrc = @baseSrc\n";
# print "baseDest = @baseDest\n";
# print "except = @except\n";
# print "code1 = $code1\n";
# print "code2 = $code2\n";
# print "log = $log\n";
# print "application = $application\n";
# print "target = $target\n";
# print "msg = $msg\n";


parsing_arguments(@ARGV);


print "VER=$ver\n";

if ( $ver eq "-off" ) {
	return true;
}

for ( $i = 0 ; $i <= $#object ; $i ++ ) {
	$tmp = $object[$i];
	for ( $j = 0 ; $j <= $#baseSrc ; $j ++ ) {
		if ( substr($tmp,0,length($baseSrc[$j]))
				eq $baseSrc[$j] ) {
			$object[$i] = $baseDest[$j] .
				  substr($tmp,length($baseSrc[$j]),100000);
			last;
		}
	}
}

open(VIN_base,"$log/versions.txt");

#print "PARSE-1\n";

while(<VIN_base>) {
	$ver_file = $_;
	$ver_file =~ s/\n//;
	$ver_file =~ s/-r/-/;
	open(VIN_rel,"$log/$ver_file.ver");
#print "$log/$ver_file.ver\n";
	while(<VIN_rel>) {
		$file = $_;
		$file =~ s/\n//;
		for ( $i = 0 ; $i <= $#prefix ; $i ++ ) {
			if ( substr($file,
					length($file)-length($prefix[$i]),
					length($prefix[$i])) eq
					$prefix[$i] ) {
				$file = substr($file,
					0,
					length($file)-length($prefix[$i]));
				last;
			}
		}
#print "target file data = $file\n";
		for ( $i = 0 ; $i <= $#object ; $i ++ ) {
#print "object = $object[$i]\n";
			if ( substr($object[$i],0,length($file))
					eq $file ) {
				goto match_file;
			}
		}
	}
	close(VIN_rel);
}

match_file:


#print "PARSE-2\n";

close(VIN_base);

@current_info = ();
$ci_version = 0;
$ci_copyright = 1;
$ci_nickname = 2;

open(VIN,$current);
while(<VIN>) {
	$tmp = $_;
	$tmp =~ s/\n//;
	$current_info[$#current_info+1] = $tmp;
}
close(VIN);


if ( $ver_file eq "current" ) {
	$ver_file = $current_info[$ci_version];
}
else {
	$ver_file_rep = $ver_file;
	$ver_file_rep =~ s/-/./g;
	$ver_file_rep =~ s/\n//g;
	$ver_file_rep =~ s/\r//g;
	$ver_file = "ver.$ver_file_rep";
}

$nickname = $current_info[unpack("C",substr($ver_file,4,1))-unpack("C","A")+$ci_nickname];

print "VERSION=$ver_file ($nickname)\n";

if ( ($ver ne "-update") && (-e $target) ) {
	open(VIN,$target);
	while(<VIN>) {
		if ( $_ eq "/* $ver_file ($nickname) */\n" ) {
			close(VIN);
			return true;
		}
		last;
	}
	close(VIN);
}

#print "PARSE-3\n";

($mday,$mon,$year) = (localtime(time))[3..5];
$year += 1900;
$mon += 1;

@sp_app = split (/\/|\\/, $application);
$app_name = $sp_app[$#sp_app];

print "app=$app_name\n";
print "msg=$msg\n";

open(VOUT,"> $target");

print (VOUT "/* $ver_file ($nickname) */\n");
print (VOUT "\n");
print (VOUT "\n");
print (VOUT "#include \"version.h\"\n");
print (VOUT "\n");
print (VOUT "\n");

print (VOUT "VERSION $code1 = {\n");
print (VOUT "\t\"$code2\",\n");
print (VOUT "\t\"$app_name\",\n");
print (VOUT "\t\"$current_info[$ci_copyright]\",\n");
print (VOUT "\t\"$ver_file($nickname)\",\n");
print (VOUT "\t$year,$mon,$mday,\n");
print (VOUT "\t0,\n");
print (VOUT "\t\"$msg\"\n");
print (VOUT "};\n\n");

close(VOUT);

#print "\n\nPARSE-4\n\n";

return true;

