/**********************************************************************
 
	Copyright (C) 2003 Hirohisa MORI <joshua@nichibun.ac.jp>
 
	This program is free software; you can redistribute it 
	and/or modify it under the terms of the GLOBALBASE 
	Library General Public License (G-LGPL) as published by 

	http://www.globalbase.org/
 
	This program is distributed in the hope that it will be 
	useful, but WITHOUT ANY WARRANTY; without even the 
	implied warranty of MERCHANTABILITY or FITNESS FOR A 
	PARTICULAR PURPOSE.

**********************************************************************/


#include	<unistd.h>
#include	"utils.h"
#include	"limits.h"

int
_numofcpu()
{
int p[2];
int id;
char buf[100];
char * ptr;
int er;
int len;
int max;
	pipe(p);
	id = fork();
	if ( id == 0 ) {
		secure_close(1);
		dup(p[1]);
		secure_close(p[0]);
		for ( id = 3 ; id <= sys_param.max_fd ; id ++ )
			secure_close(id);
	      /*system("uname -X | egrep NumCPU");*/
                system("cat /proc/cpuinfo | egrep processor");
		exit(0);
	}
	secure_close(p[1]);
	/*er = read(p[0],buf,100);*/
	ptr = buf;
	len = 99;
	for ( ; len > 0 ; ) {
	        er = read(p[0],ptr,len);
		if ( er <= 0 )
			break;
		ptr += er;
		len -= er;
	}
	*ptr = 0;
	secure_close(p[0]);
	max = 0;
	for ( ptr = buf ; *ptr ; ptr ++ )
		if ( '0' <= *ptr && *ptr <= '9' ) {
			if ( max < *ptr - '0' )
				max = *ptr - '0';
		}
	return max+1;
}
