/**********************************************************************
 
	Copyright (C) 2003 Hirohisa MORI <joshua@nichibun.ac.jp>
 
	This program is free software; you can redistribute it 
	and/or modify it under the terms of the GLOBALBASE 
	Library General Public License (G-LGPL) as published by 

	http://www.globalbase.org/
 
	This program is distributed in the hope that it will be 
	useful, but WITHOUT ANY WARRANTY; without even the 
	implied warranty of MERCHANTABILITY or FITNESS FOR A 
	PARTICULAR PURPOSE.

**********************************************************************/

#include "xl.h"
#include "gb.h"
#include "mx_format.h"

void
init_gbview_function(XLISP_ENV * env0, XLISP_ENV * env1)
{
	init_gv_frame_open(env0);
	init_gv_frame_close(env0);
	init_gv_frame_status(env0);
	init_gv_frame_set_status(env0);
	init_gv_frame_point_status(env0);
	init_gv_frame_zoom(env0);
	init_gv_frame_move(env0);
	init_gv_frame_rotate(env0);
	init_gv_frame_redraw(env0);
	init_gv_frame_get_image(env0);
	init_gv_frame_click(env0);
	init_gv_frame_event(env0);
	init_gv_frame_purge_select(env0);
	init_gv_frame_dec_seq(env0);
	init_gv_frame_set_overlay(env0);
	init_gv_frame_radar(env0);
	init_gv_frame_loading_status(env0);

	init_gv_http_agent(env0,env1);
	
	init_gvImageSpider(env0,env1);
	init_gvGetWorldfile(env0,env1);
	init_gmx_lib_function(env0,env1);

}

